/*
In order to a

*/

<Cabbage>

#define PROPERTY_SLIDER_OSCA colour(3, 1, 108, 255) colour(3, 1, 108, 255) fontcolour("white") outlinecolour(39, 6, 142, 255) textcolour(6, 1, 65, 255) trackercolour(255, 40, 53, 255)
#define PROPERTY_CHKBOX_OSCA colour:1(255, 40, 53, 255) colour:1(255, 40, 53, 255) fontcolour:0(0, 0, 0, 255) fontcolour:1(0, 0, 0, 255)
#define PROPERTY_BUT_OSCA colour:0(57, 127, 243, 255) colour:0(57, 127, 243, 255) colour:1(34, 49, 190, 255) fontcolour("white")
#define PROPERTY_SLIDER_OSCA2 colour(3, 1, 108, 255) colour(3, 1, 108, 255) fontcolour("black") outlinecolour(39, 6, 142, 255) textcolour(6, 1, 65, 255) trackercolour(255, 40, 53, 255)


form caption("Morpheur") size(840, 340), colour(58, 110, 210), pluginID("Mor1")

keyboard bounds(1,281, 839, 58) mouseoeverkeycolour(255, 255, 0, 128)
;-----------------------------------
;- Region: Menu GUI
;----------------------------------
groupbox bounds(0, 0, 140, 280) identchannel("GB_Menu") text("Menu") colour(178, 186, 230, 255) fontcolour:0(0, 0, 0, 255) outlinecolour(9, 16, 91, 255)
  {
  button bounds(10, 30, 120, 30) channel("But_Call_MainOsc") value(1) text("Oscillator") radiogroup(1) $PROPERTY_BUT_OSCA
  button bounds(10, 70, 120, 30) channel("But_Call_ADSR")  text("Envelope") radiogroup(1) $PROPERTY_BUT_OSCA
  button bounds(10, 110, 120, 30) channel("But_Call_Filters")  text("Filters") radiogroup(1) $PROPERTY_BUT_OSCA
  button bounds(10, 150, 120, 30) channel("But_Call_Effects")  text("Effects") radiogroup(1) $PROPERTY_BUT_OSCA
  filebutton bounds(10, 200, 55, 30) channel("filebutton") value(0) text("Save", "Save") mode("snapshot") $PROPERTY_BUT_OSCA
  combobox bounds(10, 235, 120, 30) channel("PresetCombo") identchannel("R_PresetCombo") value(0) populate("*.snaps")
  button bounds(70, 190, 55, 40) channel("But_Call_Panic")  text("PANIC") latched(0) $PROPERTY_BUT_OSCA
}


;-----------------------------------
;- Region: Main Oscillator GUI
;----------------------------------
groupbox bounds(140, 0, 700, 280) identchannel("GB_MainOSc") text("Main Oscilators") visible(1) colour(178, 186, 230, 255) fontcolour:0(0, 0, 0, 255) outlinecolour(9, 16, 91, 255)
  {
  filebutton bounds(10, 20, 80, 20) channel("filenameOscA") value(0) text("Open File", "Open File") populate("", "") shape("ellipse")
  soundfiler bounds(10, 43, 230, 100) channel("beg", "len") identchannel("filerOscA") colour(50, 214, 214, 255) fontcolour:0(160, 160, 160, 255) fontcolour:1(160, 160, 160, 255) tablenumber(901) zoom(0)
  filebutton bounds(10, 150, 80, 20) channel("filenameOscB") value(0) text("Open File", "Open File") populate("", "") shape("ellipse")
  soundfiler bounds(10, 172, 230, 100) channel("beg", "len") identchannel("filerOscB") colour(50, 214, 214, 255) fontcolour:0(160, 160, 160, 255) fontcolour:1(160, 160, 160, 255) tablenumber(902) zoom(0)
  ;UNCOMMENT following line to show CSound output for debbuging
  ;csoundoutput bounds(10, 43, 230, 100)    ;

  ;-----------------------------------
  ;- Region:    ___1-SubOscilOscillator GUI
  ;  SubOscillator
  rslider bounds(240, 30, 90, 100) channel("OscA_SubOsc") range(-2, 0, 0, 1, 1) text("SubOsc")  max(0) min(-2) increment(1) valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  rslider bounds(330, 30, 90, 100) channel("OscA_SubOsc_Mix") range(0, 1, 0, 1, .01) text("Mix") value(0.5) max(1) min(0) increment(.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region:    ___2-Morphing Frequence
  encoder bounds(250, 150, 100, 120) channel("Enc_Freq_Morph") value(0.5) text("Morph Freq")   max(5) min(0.000) increment(0.001) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  checkbox bounds(350, 190, 120, 12) channel("ChkBox_Sin") value(1) text("Sine curve")   radiogroup(2) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(350, 210, 120, 12) channel("ChkBox_Seg")   text("Line segments")     radiogroup(2) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(350, 230, 120, 12) channel("ChkBox_Exp")   text("Exponential seg")     radiogroup(2) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(350, 250, 120, 12) channel("ChkBox_Line")   text("No Cycle")     radiogroup(2) shape("circle") $PROPERTY_CHKBOX_OSCA

  ;-----------------------------------
  ;- Region:    ___3-FM Oscillator
  filebutton bounds(460, 20, 80, 20) channel("filenameOscC") value(0) text("Open File", "Open File") populate("", "") shape("ellipse")
  soundfiler bounds(460, 43, 230, 100) channel("beg", "len") identchannel("filerOscC") colour(50, 214, 214, 255) fontcolour:0(160, 160, 160, 255) fontcolour:1(160, 160, 160, 255) tablenumber(903) zoom(0)
  encoder bounds(480, 150, 100, 120) channel("Enc_Freq_Mod") value(0) text("Freq Mod")  max(5) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(580, 150, 100, 120) channel("Enc_Amp_Mod") value(1) text("Mod factor")  max(25) min(0.1) increment(0.1) valuetextbox(1) $PROPERTY_SLIDER_OSCA

  label bounds(100, 22, 100, 16)  text("Oscillator A") fontcolour:0(0, 0, 0, 255)
  label bounds(100, 152, 100, 16) text("Oscillator B") fontcolour:0(0, 0, 0, 255)
  label bounds(550, 22, 100, 16)  text("Oscillator FM") fontcolour:0(0, 0, 0, 255)
  label bounds(340, 165, 100, 14) text("Morph. shape") fontcolour:0(0, 0, 0, 255)
}


;-----------------------------------
;- Region: Volume Enveloppe GUI
;----------------------------------
groupbox bounds(140, 0, 700, 280) identchannel("GB_ADSR") text("Envelope") visible(0) colour(178, 186, 230, 255) fontcolour:0(0, 0, 0, 255) outlinecolour(9, 16, 91, 255)
  {
  encoder bounds(0, 20, 100, 120) channel("Enc_ADSR_Attack") identchannel("R_Enc_ADSR_Attack") value(0.01) text("Attack")  max(2) min(0.001) increment(0.001) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(100, 20, 100, 120) channel("Enc_ADSR_Decay") identchannel("R_Enc_ADSR_Decay")  value(0.01) text("Decay")  max(2) min(0.001) increment(0.001) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(200, 20, 100, 120) channel("Enc_ADSR_Sustain") identchannel("R_Enc_ADSR_Sustain") value(0.85) text("Sustain")  max(1) min(0.0) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(300, 20, 100, 120) channel("Enc_ADSR_Release") identchannel("R_Enc_ADSR_Release") value(0.01) text("Release")  max(3) min(0.00) increment(0.001) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  checkbox bounds(400, 60, 120, 12) channel("ChkBox_ADSR_AD")  text("AD")   radiogroup(3) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(400, 80, 120, 12) channel("ChkBox_ADSR_ADSR")  value(1) text("ADSR")     radiogroup(3) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(400, 100, 120, 12) channel("ChkBox_ADSR_EXPADSR")   text("Exp. ADSR")     radiogroup(3) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(400, 120, 120, 12) channel("ChkBox_ADSR_REV")   text("Reverse ADSR")     radiogroup(3) shape("circle") $PROPERTY_CHKBOX_OSCA
}


;-----------------------------------
;- Region: Filters GUI
;----------------------------------

groupbox bounds(140, 0, 700, 280) identchannel("GB_Filters") text("Filters") visible(0) colour(178, 186, 230, 255) fontcolour:0(0, 0, 0, 255) outlinecolour(9, 16, 91, 255)
  {
  checkbox bounds(20, 3, 70, 13) channel("ChkBox_Filter_On") text("On/Off") shape("circle") $PROPERTY_CHKBOX_OSCA

  ;-----------------------------------
  ;- Region: ___1-Encoders
  rslider bounds(0, 20, 90, 100) channel("Enc_Filter_Mix") range(0,1,0.5,1,0.01) text("Mix") valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  encoder bounds(90, 20, 90, 100) channel("Enc_Filter_CutOff") identchannel("R_Enc_Filter_CutOff") value(500) text("Cut Off")  max(3500) min(20) increment(5) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(180, 20, 90, 100) channel("Enc_Filter_Reson") identchannel("R_Enc_Filter_Reson") value(0.0) text("Resonance")  max(1) min(0.0) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder bounds(270, 20, 90, 100) channel("Enc_Filter_Distor")  identchannel("R_Enc_Filter_Distor") value(0.01) text("Distorsion")  max(1) min(0.00) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA

  ;-----------------------------------
  ;- Region: ___2-CheckBoxes
  checkbox bounds(370, 30, 100, 12) channel("ChkBox_Filter_Moogl")  text("Moogladder")  value(1) radiogroup(4) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(370, 50, 100, 12) channel("ChkBox_Filter_LPF18")   text("LPF18")   radiogroup(4) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(370, 70, 80, 12) channel("ChkBox_Filter_BQRez")   text("BQRez")    radiogroup(4) shape("circle") $PROPERTY_CHKBOX_OSCA
  combobox bounds(370, 90, 90, 14) channel("Combo_Filter_BQRez") identchannel("R_Combo_Filter_BQRez") items("Low-Pass", "High-Pass", "Band-pass", "Band-Reject", "All-Pass")
  checkbox bounds(490, 30, 70, 12) channel("ChkBox_Filter_Tone")      text("Tone")     radiogroup(4) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(490, 50, 70, 12) channel("ChkBox_Filter_aTone")     text("aTone")     radiogroup(4) shape("circle") $PROPERTY_CHKBOX_OSCA
  hslider bounds(550, 30, 140, 15) channel("Slider_Filter_Tonelayer") range(1,10,1,1,1)  valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  hslider bounds(550, 50, 140, 15) channel("Slider_Filter_aTonelayer") range(1,10,1,1,1)  valuetextbox(1) $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___3-Pitch Follow
  checkbox bounds(5, 145, 100, 12) channel("ChkBox_Filter_PitchFollowOn")   text("Pitch Follow")     shape("circle") $PROPERTY_CHKBOX_OSCA
  encoder  bounds(-5, 165, 90, 70)   channel("Enc_Filter_Follow")      identchannel("R_Enc_Filter_Follow")   value(0)   max(2400) min(-2400) increment(10) valuetextbox(1) $PROPERTY_SLIDER_OSCA

  ;-----------------------------------
  ;- Region: ___4-Cut-Off LFO
  image    bounds(100, 130, 190, 130)  colour(216, 191, 216, 255)
  label    bounds(160, 135, 80, 14) text("Cut-Off LFO") fontcolour(0, 0, 0, 255)
  checkbox bounds(105, 135, 12, 12) channel("ChkBox_Filter_CutOff_LFO_On") value(0)     shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(110, 170, 80, 12) channel("ChkBox_Filter_CutOff_Line")   text("Line") value(1)  radiogroup(5) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(110, 190, 80, 12) channel("ChkBox_Filter_CutOff_Sine")   text("Sine")   radiogroup(5) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(110, 210, 80, 12) channel("ChkBox_Filter_CutOff_Seg")   text("Seg")    radiogroup(5) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(110, 230, 80, 12) channel("ChkBox_Filter_CutOff_Exp")   text("Exp")    radiogroup(5) shape("circle") $PROPERTY_CHKBOX_OSCA
  encoder  bounds(150, 150, 90, 90) channel("Enc_Filter_CutOff_Amp") identchannel("R_Enc_Filter_CutOff_Amp") text("Amp")  value(0.01)   max(2) min(0) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder  bounds(210, 150, 90, 90) channel("Enc_Filter_CutOff_Freq") identchannel("R_Enc_Filter_CutOff_Freq") text("Freq")  value(0.01)   max(4) min(0.01) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA

  ;-----------------------------------
  ;- Region: ___5-Resonnance LFO
  image    bounds(300, 130, 190, 130)  colour(216, 191, 216, 255)
  label    bounds(300, 135, 200, 14) text("Resonance LFO") fontcolour(0, 0, 0, 255)
  checkbox bounds(305, 135, 12, 12) channel("ChkBox_Filter_Reson_LFO_On") value(0)    shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(310, 170, 80, 12) channel("ChkBox_Filter_Reson_Line")   text("Line")   value(1)   radiogroup(6) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(310, 190, 80, 12) channel("ChkBox_Filter_Reson_Sine")   text("Sine")   radiogroup(6) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(310, 210, 80, 12) channel("ChkBox_Filter_Reson_Seg")   text("Seg")    radiogroup(6) shape("circle") $PROPERTY_CHKBOX_OSCA
  checkbox bounds(310, 230, 80, 12) channel("ChkBox_Filter_Reson_Exp")   text("Exp")    radiogroup(6) shape("circle") $PROPERTY_CHKBOX_OSCA
  encoder  bounds(350, 150, 90, 90) channel("Enc_Filter_Reson_Amp") identchannel("R_Enc_Filter_Reson_Amp") text("Amp")  value(0.01)   max(1) min(0) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder  bounds(410, 150, 90, 90) channel("Enc_Filter_Reson_Freq") identchannel("R_Enc_Filter_Reson_Freq") text("Freq")  value(0.01)   max(4) min(0.01) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA

  ;-----------------------------------
  ;- Region: ___6-Filter ADSR
  image    bounds(500, 130, 190, 130)  colour(216, 191, 216, 255)
  label    bounds(500, 135, 200, 14) text("F. Audio ADSR") fontcolour(0, 0, 0, 255)
  checkbox bounds(505, 135, 50, 14) channel("ChkBox_Filter_Env_On")   text("On")  value(0)  shape("circle") $PROPERTY_CHKBOX_OSCA
  encoder  bounds(480, 160, 85, 80) channel("Enc_Filter_Env_Att") identchannel("R_Enc_Filter_Env_Att") text("Att")  value(0.5)   max(4) min(0.01) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder  bounds(530, 160, 85, 80) channel("Enc_Filter_Env_Dec") identchannel("R_Enc_Filter_Env_Dec") text("Dec")  value(0.5)   max(4) min(0.01) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder  bounds(580, 160, 85, 80) channel("Enc_Filter_Env_Sus") identchannel("R_Enc_Filter_Env_Sus") text("Sus")  value(.9)   max(1) min(0) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  encoder  bounds(630, 160, 85, 80) channel("Enc_Filter_Env_Rel") identchannel("R_Enc_Filter_Env_Rel") text("Rel")  value(0.7)   max(4) min(0.01) increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA

}


;-----------------------------------
;- Region: Effect GUI
;-----------------------------------
groupbox bounds(140, 0, 700, 280) identchannel("GB_Effects") text("Effects") visible(0) colour(178, 186, 230, 255) fontcolour:0(0, 0, 0, 255) outlinecolour(9, 16, 91, 255)
  {

  ;-----------------------------------
  ;- Region: ___1-Reverb
  image    bounds(5, 20, 160, 100)  colour(216, 191, 216, 255)
  label bounds(5, 25, 160, 14) text("Reverb") fontcolour(0, 0, 0, 255)
  checkbox bounds(10, 25, 12, 12) channel("Reverb_On") shape("circle") $PROPERTY_CHKBOX_GENE
  rslider bounds(0, 40, 70, 75) channel("Reverb_Room") range(0,1,0.8,1,0.01)  text("Room")  valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  rslider bounds(50, 40, 70, 75) channel("Reverb_Damp") range(0,1,0.8,1,0.01)  text("Damp")  valuetextbox(1)  $PROPERTY_SLIDER_OSCA2
  rslider bounds(100, 40, 70, 75) channel("Reverb_Mix") range(0,1,0.5,1,0.01) text("Mix")  valuetextbox(1) $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___2-Echo
  image    bounds(170, 20, 120, 100)  colour(216, 191, 216, 255)
  label bounds(170, 25, 120, 14) text("Echo") fontcolour(0, 0, 0, 255)
  checkbox bounds(175, 25, 12, 12) channel("Echo_On") shape("circle") $PROPERTY_CHKBOX_GENE
  rslider bounds(170, 40, 70, 75) channel("Echo_Delay") min(0.5) max(6) value(1.5) text("Delay") increment(0.1) valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  rslider bounds(220, 40, 70, 75) channel("Echo_Loop") min(0.01) max(6) value(0.1) text("After")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___3-Ring modulation
  image    bounds(295, 20, 180, 100)  colour(216, 191, 216, 255)
  label bounds(295, 25, 160, 14) text("Ring Mod") fontcolour(0, 0, 0, 255)
  checkbox bounds(300, 25, 12, 12) channel("Ring_On")  shape("circle") $PROPERTY_CHKBOX_GENE
  rslider bounds(290, 40, 70, 75) channel("Ring_Amp") range(0, 2, 2, 1, 0.01) text("Amp") increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  encoder bounds(340, 40,  100,75)  channel("Ring_Freq") value(385) increment(1) text("Freq")  max(1500) min(0.1) valuetextbox(1) $PROPERTY_SLIDER_OSCA
  rslider bounds(410, 40, 70, 75) channel("Ring_Offset") range(0, 1, 1, 1, 0.01) text("Offset") increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___4-Flanger
  image    bounds(480, 20, 180, 100)  colour(216, 191, 216, 255)
  label bounds(485, 25, 180, 14) text("Flanger") fontcolour(0, 0, 0, 255)
  checkbox bounds(485, 25, 12, 12) channel("Flanger_On")  shape("circle") $PROPERTY_CHKBOX_GENE
  rslider bounds(480, 40, 70, 75) channel("Flanger_Depth") min(0) max(200) value(20) text("Depth") increment(0.01) valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  rslider bounds(540, 40, 70, 75) channel("Flanger_Freq") min(0.0) max(200) value(20) text("Freq")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2
  rslider bounds(600, 40, 70, 75) channel("Flanger_FeedBack") min(0.0) max(1) value(0.5) text("FeedBck")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___4-Chorus
  image    bounds(420, 130, 240, 100)  colour(216, 191, 216, 255)
  label bounds(425, 135, 240, 14) text("Chorus") fontcolour(0, 0, 0, 255)
  checkbox bounds(425, 135, 12, 12) channel("Chorus_On")  shape("circle") $PROPERTY_CHKBOX_GENE
  rslider bounds(420, 150, 70, 75) channel("Chorus_Rate") min(0.0) max(1) value(0.2) text("Rate")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2
  rslider bounds(480, 150, 70, 75) channel("Chorus_Min") min(0) max(50) value(14) text("Min") increment(0.1) valuetextbox(1) $PROPERTY_SLIDER_OSCA2
  rslider bounds(540, 150, 70, 75) channel("Chorus_Max") min(0.0) max(50) value(20) text("Max")  increment(1) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2
  rslider bounds(600, 150, 70, 75) channel("Chorus_Mix") min(0.0) max(1) value(0.8) text("Mix")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2

  ;-----------------------------------
  ;- Region: ___5-Gain
  image    bounds(5, 130, 90, 100)  colour(216, 191, 216, 255)
  rslider bounds(10, 140, 70, 75) channel("MainGain") min(0.0) max(1) value(0.5) text("Main Gain")  increment(0.01) valuetextbox(1)  $PROPERTY_SLIDER_OSCA2
 
  ;-----------------------------------
  ;- Region: ___6-Host Slave
  image    bounds(100, 130, 90, 100)  colour(216, 191, 216, 255)
  label bounds(100, 135, 90, 14) text("Host") fontcolour(0, 0, 0, 255)
  checkbox bounds(105,150, 60, 12) channel("HostSlave_On") text("Slave") shape("circle") $PROPERTY_CHKBOX_GENE textcolour(0, 0, 0, 255) fontcolour(0, 0, 0, 255)
  numberbox bounds(110, 163, 70, 30) channel("HostBPMValue")  text("BPM")  textcolour(0, 0, 0, 255) min(0) max(360)
  numberbox bounds(110, 195, 70, 30) channel("HostMorphValue")  text("Frq Morph")  textcolour(0, 0, 0, 255) min(0) max(360)
 
  ;-----------------------------------
  ;- Region: ___7-BinAural
  image    bounds(195, 130, 125, 100)  colour(216, 191, 216, 255)
  label bounds(200, 135, 135, 14) text("BinAural") fontcolour(0, 0, 0, 255)
  checkbox bounds(200,135, 12, 12)  channel("ChkBox_Binaural")  shape("circle") $PROPERTY_CHKBOX_GENE textcolour(0, 0, 0, 255) fontcolour(0, 0, 0, 255)
  encoder bounds(180, 145, 100,75) channel("Enc_Azimut") text("Azimut") valuetextbox(1) min(-90) max(180) increnent(1) value(0) $PROPERTY_SLIDER_OSCA
  encoder bounds(230, 145,  100,75) channel("Enc_Elev") text("Elevation") valuetextbox(1) min(-40) max(90) increnent(1) value(0) $PROPERTY_SLIDER_OSCA

}

</Cabbage>


<CsoundSynthesizer>

<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d ; --midi-key=4 --midi-velocity-amp=5 ;--midi-key-cps=4
</CsOptions>


<CsInstruments>
; Initialize the global variables.
sr = 44100
;kr = 4410
ksmps =32
nchnls = 2
0dbfs = 1
pgmassign 0, 800
pgmassign 0, 1

; Init global variable
giSine	 ftgen	0, 0, 4097, 10, 1						; sine wave

/* In order to change the first time loaded files, you have to edit the the instrument InitData
 and change the values of the following variable : 
 
            gSfilepathOscA     
            gSfilepathOscB 
            gSfilepathOscC 
            
 Also, place the wav file into the same directory as the morpheur is
*/


gSfilepathOscA init     "C:/Users/Cube/Documents/Csound/WaveForms/AKWF_0003/AKWF_0203.wav"
gSfilepathOscB init     "C:/Users/Cube/Documents/Csound/WaveForms/AKWF_0003/AKWF_0203.wav"
gSfilepathOscC init     "C:/Users/Cube/Documents/Csound/WaveForms/AKWF_0003/AKWF_0203.wav"


/* The following file are available in Csound Documentation,
just copy paste them into where Morpheur Synth is
and provide the path */
gS_StereoFileLeft init  "C:/Users/Cube/Documents/Csound/hrtf-44100-left.dat"
gS_StereoFileRight init  "C:/Users/Cube/Documents/Csound/hrtf-44100-right.dat"


; init variables for filters
gkFl_GB_Filt init 0
gkFilter_is_On init 0
gkFilter_Type init 0
giBQrez_Type init 0
giToneLayer init 1
giAToneLayer init 1
gkFilter_Mix  init 0.5
gkFilter_CutOff  init 500
gkFilter_Reson init 0
gkFilter_Distor init 0.01
gkFilter_PitchFollow init 0
gkFilter_PitchFollow_Value init 0
gkFilter_CutOff_LFO_is_On init 0
gkFilter_CutOff_Amp init 0.01
gkFilter_CutOff_Freq init 0.01
gkFilter_CutOff_LFO_Mode init 1
gkFilter_Reson_LFO_is_On init 0
gkFilter_Reson_Amp init 0.01
gkFilter_Reson_Freq init 0.01
gkFilter_Reson_LFO_Mode init 1
gkFilter_Env_is_On init 0
gkFilter_Env_Att init 0.5
gkFilter_Env_Dec init 0.5
gkFilter_Env_Sus init 0.9
gkFilter_Env_Rel init 0.7

; Factor for linking Host Tempo to LFOs of Morpheur 9not every thing is implemented at this time
gkTempoFactor init 1

gkStereo init 0
gkReverb_On init 0
gkEcho_On init 0
gkAfttch init 0

gkFilter_Reson_LFO_On init 0
gkFilter_CutOff_LFO_On init 0



;*****************************************************
;- Region: U D O
;*****************************************************



opcode	MIDI_trigger_instrument,0,	ii				;INPUT ARGUMENT FOR INSTRUMENT NUMBER OF THE INSTRUMENT TO BE TRIGGERED AND THE MIDI CHANNEL ON WHICH TRIGGERING WILL OCCUR (VALUE OF ZERO HERE MEANS THAT NOTES WILL BE TRIGGERED ON ALL CHANNELS)
	
		insno,ichan	xin						;READ IN INPUT ARGUMENTS
		

	gkAftouch=0		
	kstatus, kchan, kdata1, kdata2  midiin				;READ IN MIDI
	; printks "kstatus %d    kchan %d    aft : %d    data2 %d   Myaft %f\n",0.5,kstatus,kchan,kdata1,kdata2

	if kchan==ichan||ichan==0 then					;IF A MESSAGE ON THE CORRECT CHANNEL HAS BEEN RECEIVED (OR ON ANY CHANNEL IF CHANNEL WAS DEFINED AS ZERO)
	    if kstatus==144 then						;IF MIDI MESSAGE IS A NOTE...
	        if kdata2>0 then						;IF VELOCITY IS MORE THAN ZERO, I.E. NOT A NOTE OFF	  
	 	        event "i",insno+(kdata1*0.001),0,-360,kdata1,kdata2	;TRIGGER INSTRUMENT WITH A HELD NOTE. NOTE NUMBER TRANSMITTED AS p4, VELOCITY AS p5
	        else								;OTHERWISE (I.E. MUST BE A NOTE OFF / ZERO VELOCITY)	  
	            turnoff2	insno+(kdata1*0.001),4,1			;TURN OFF INSTRUMENT WITH THIS SPECIFIC FRACTIONAL NOTE NUMBER
	        endif								;END OF CONDITIONAL BRANCH
	    elseif kstatus==128 then					;IF MESSAGE USES A 'NOTE OFF' STATUS BYTE (128)
	        gkAfttch=0
	        turnoff2	insno+(kdata1*0.001),4,1			;TURN OFF INSTRUMENT WITH THIS SPECIFIC FRACTIONAL NOTE NUMBER	 								;END OF CONDITIONAL BRANCH
	    elseif kstatus==208 then
            gkAfttch = kdata1/127 ; between 0 and 1
      ; printks2 "gkmod %f \n",gkAftouch
      ;  printks "kstatus %d    kchan %d    aft : %d    data2 %d   Myaft %f\n",0,kstatus,kchan,kdata1,kdata2,gkAftouch
        endif
 
	
	endif								;END OF CONDITIONAL BRANCH
endop


/*
opcode	MIDI_trigger_instrument,0,	ii				;INPUT ARGUMENT FOR INSTRUMENT NUMBER OF THE INSTRUMENT TO BE TRIGGERED AND THE MIDI CHANNEL ON WHICH TRIGGERING WILL OCCUR (VALUE OF ZERO HERE MEANS THAT NOTES WILL BE TRIGGERED ON ALL CHANNELS)
	
		insno,ichan	xin						;READ IN INPUT ARGUMENTS
	knotelength    init    0
knoteontime    init    0

kstatus, kchan, kdata1, kdata2                  midiin

if (kstatus == 128) then
knoteofftime    times
knotelength    =    knoteofftime - knoteontime
printks "kstatus= %d, kchan = %d, \\tnote#  = %d, velocity = %d \\tNote OFF\\t%f %f\\n", 0, kstatus, kchan, kdata1,kdata2, knoteofftime, knotelength
 turnoff2	insno+(kdata1*0.001),4,1			;TURN OFF INSTRUMENT WITH THIS SPECIFIC FRACTIONAL NOTE NUMBER	 	
elseif (kstatus == 144) then
knoteontime    times
printks "kstatus= %d, kchan = %d, \\tnote#  = %d, velocity = %d \\tNote ON\\t%f\\n", 0, kstatus, kchan, kdata1, kdata2, knoteontime
 event "i",insno+(kdata1*0.001),0,-3600,kdata1,kdata2	;TRIGGER INSTRUMENT WITH A HELD NOTE. NOTE NUMBER TRANSMITTED AS p4, VELOCITY AS p5

elseif (kstatus == 160) then
printks "kstatus= %d, kchan = %d, \\tkdata1 = %d, kdata2 = %d \\tPolyphonic Aftertouch\\n", 0, kstatus, kchan, kdata1, kdata2

elseif (kstatus == 176) then
printks "kstatus= %d, kchan = %d, \\t CC = %d, value = %d \\tControl Change\\n", 0, kstatus, kchan, kdata1, kdata2

elseif (kstatus == 192) then
printks "kstatus= %d, kchan = %d, \\tkdata1 = %d, kdata2 = %d \\tProgram Change\\n", 0, kstatus, kchan, kdata1, kdata2

elseif (kstatus == 208) then
printks  "kstatus= %d, kchan = %d, \\tkdata1 = %d, kdata2 = %d \\tChannel Aftertouch\\n", 0, kstatus, kchan, kdata1, kdata2

elseif (kstatus == 224) then
printks "kstatus= %d, kchan = %d, \\t ( data1 , kdata2 ) = ( %d, %d )\\tPitch Bend\\n", 0, kstatus, kchan, kdata1, kdata2

endif	
endop
*/

;*****************************************************
;- Region: _1: Flanger
;*****************************************************
opcode Flanger,a,akkk
  aIn,kFlgDepth,kFlgFreq,kFeedBck  xin
  aDel     poscil3  kFlgDepth/2000, kFlgFreq/2000
  aOut flanger aIn,   aDel, kFeedBck
  xout aOut
endop


;*****************************************************
;- Region: _2:Chorus
;*****************************************************
/*****************************************************
asig Chorus ain,kf,kmin,kmax
ain - input signal
kf - noise generator frequency
kmin - min delay
kmax - max delay
*****************************************************/
opcode Chorus,a,akkkk
  asig,kf,kmin,kmax,kmix xin
    
  idel = 0.1
  im = 2/sr
  km = kmin < kmax ? kmin : kmax
  kmx = kmax > kmin ? kmax : kmin
  kmx = (kmx < idel ? kmx : idel)
  km = (km > im ? km : im)
  kwdth = kmx - km
  ;amod lfo kwdth,kf
  amod  oscil3     kwdth, kf, giSine,0
  amod2  oscil3     kwdth, kf, giSine,0.25
  ;amod randi kwdth,kf,2,1
  amod = (amod + kwdth)/2
  amod2 = (amod2 + kwdth)/2
  admp delayr idel
  adel deltap3 amod+km
  adel2 deltap3 amod2+km
  delayw asig
  aOut sum adel*0.5*sqrt(kmix), adel2*.5*sqrt(kmix), asig*(1-sqrt(kmix))
  xout adel + asig
endop



;All filters are turned into UDO because it will be easier to reuse them into another synth (copy paste the groupbox also)
;*****************************************************
;- Region: _3:Filters
;*****************************************************

;--------------------------------------------
;- Region: __1:OP MOOGLADDER

opcode My_Moogladder, a, akkkkkkkkkkkkk

  /*--------------------------------------------
  The filter accepts the following parameters

  aIn                : audio signal input
  kCutOff            : Cut Off Frequency
  kResonLoc          : Amount of Resonnance (between 0 and 1)
  kPitchF_on         : If user want to follow the pitch of the input note. If yes, then CutOff frequency is unused
  kPitchF_Val        : Factor to shift the pitch follow cut off (cent() of the note. Between -2400 and + 2400, @ octaves
  kPitch             : Pitch (freq) of the note played on keyborad
  kLFOCutOff_on      : activate or not the LFO on the CutOff Frequency
  kLFOCutOff_mode    : Type of modulator for the cut Off (0 : ramp, 1: sine, 2: triangle, 3: expon segments
  kLFOCutOff_amp     : Amplitude of cut Off modulation in ]0,1]
  kLFOCutOff_freq    : Frequency of cut Off modulation in ]0,5]
  kLFOReson_on       : activate or not the LFO on the Resonnance
  kLFOReson_mode     : Type of modulator for the Resonance (0 : ramp, 1: sine, 2: triangle, 3: expon segments
  kLFOReson_amp      : Amplitude of resonance modulation in ]0,1]
  LFOReson_freq      : Frequency of resonance modulation
  */

  aIn,  kCutOff , kResonLoc, kPitchF_on, kPitchF_Val, kPitch, \
  kLFOCutOff_on, kLFOCutOff_mode,kLFOCutOff_amp, kLFOCutOff_freq  ,\
  kLFOReson_on, kLFOReson_mode,kLFOReson_amp, kLFOReson_freq     xin

  if kPitchF_on==1 then
      kCutOffLoc = kPitch * cent(kPitchF_Val)
  else
      kCutOffLoc =kCutOff
  endif

  if kLFOCutOff_on ==1 then
      if kLFOCutOff_mode ==0 then
          iDur = i( kLFOCutOff_freq)
          kLFO_CutOff linsegr 0.01, 1 / iDur , i(kLFOCutOff_amp),0.1, i(kLFOCutOff_amp)
      elseif kLFOCutOff_mode == 1 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,0       ; Apply a sine waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==2 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,1       ; Apply a triangle waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==3 then
          kLFO_CutOff looptseg kLFOCutOff_freq,0,0,  1-0.5*kLFOCutOff_amp ,6,1,  1+0.5* kLFOCutOff_amp,6, 1, 1-0.5*kLFOCutOff_amp
      endif
  else
      kLFO_CutOff=1
  endif
  kCutOffLoc = kCutOffLoc*kLFO_CutOff
  ; Resonnace
  if kLFOReson_on ==1 then
      if kLFOReson_mode ==0 then
          iDur = i( kLFOReson_freq)
          kLFO_Reson linsegr 0.01, 1 / iDur , i(kLFOReson_amp),0.1, i(kLFOReson_amp)
      elseif kLFOReson_mode == 1 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,0       ; Apply a sine waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==2 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,1       ; Apply a triangle waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==3 then
          kLFO_Reson looptseg kLFOReson_freq,0,0,  kLFOReson_amp ,6,1,  0,6, 1,  kLFOReson_amp
      endif
  else
      kLFO_Reson=1
  endif
  kResonLoc = kResonLoc*kLFO_Reson
  aOutLoc moogladder2 aIn,  kCutOffLoc , kResonLoc
  xout aOutLoc
endop

 
 
;--------------------------------------------
;- Region: __2: OP LPF18

opcode My_LPF18, a, akkkkkkkkkkkkkk

  /*--------------------------------------------
  See MoogLadder for parameters
 
  kDistor : Amount of distorsion

  */
  aIn,  kCutOff , kResonLoc, kPitchF_on, kPitchF_Val, kPitch, \
  kLFOCutOff_on, kLFOCutOff_mode,kLFOCutOff_amp, kLFOCutOff_freq  ,\
  kLFOReson_on, kLFOReson_mode,kLFOReson_amp, kLFOReson_freq,\
  kDistor     xin

  if kPitchF_on==1 then
      kCutOffLoc = kPitch * cent(kPitchF_Val)
  else
      kCutOffLoc =kCutOff
  endif

  if kLFOCutOff_on ==1 then
      if kLFOCutOff_mode ==0 then
          iDur = i( kLFOCutOff_freq)
          kLFO_CutOff linsegr 0.01, 1 / iDur , i(kLFOCutOff_amp),0.1, i(kLFOCutOff_amp)
      elseif kLFOCutOff_mode == 1 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,0       ; Apply a sine waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==2 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,1       ; Apply a triangle waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==3 then
          kLFO_CutOff looptseg kLFOCutOff_freq,0,0,   1-0.5*kLFOCutOff_amp ,6,1,  1+0.5* kLFOCutOff_amp,6, 1,  1-0.5*kLFOCutOff_amp
      endif
  else
      kLFO_CutOff=1
  endif
  kCutOffLoc = kCutOffLoc*kLFO_CutOff
  ; REsonnace
  if kLFOReson_on ==1 then
      if kLFOReson_mode ==0 then
          iDur = i( kLFOReson_freq)
          kLFO_Reson linsegr 0.01, 1 / iDur , i(kLFOReson_amp),0.1, i(kLFOReson_amp)
      elseif kLFOReson_mode == 1 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,0       ; Apply a sine waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==2 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,1       ; Apply a triangle waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==3 then
          kLFO_Reson looptseg kLFOReson_freq,0,0,  kLFOReson_amp ,6,1,  0,6, 1, kLFOReson_amp
      endif
  else
      kLFO_Reson=1
  endif

  kResonLoc = kResonLoc*kLFO_Reson
  aOutLoc lpf18 aIn,  kCutOffLoc , kResonLoc ,kDistor
  xout aOutLoc
endop



;--------------------------------------------
;- Region: __3: OP BQREZ
;--------------------------------------------

opcode My_BQRez, a, akkkkkkkkkkkkkj

  /*--------------------------------------------
  See MoogLadder for parameters
 
  + imode : Select the type of the filter (see BQRez Csound manual page)

  */

  aIn,  kCutOff , kResonLoc, kPitchF_on, kPitchF_Val, kPitch, \
  kLFOCutOff_on, kLFOCutOff_mode,kLFOCutOff_amp, kLFOCutOff_freq  ,\
  kLFOReson_on, kLFOReson_mode,kLFOReson_amp, kLFOReson_freq ,imode    xin

  if kPitchF_on==1 then
      kCutOffLoc = kPitch * cent(kPitchF_Val)
  else
      kCutOffLoc =kCutOff
  endif

  if kLFOCutOff_on ==1 then
      if kLFOCutOff_mode ==0 then
          iDur = i( kLFOCutOff_freq)
          kLFO_CutOff linsegr 0.01, 1 / iDur , i(kLFOCutOff_amp),0.1, i(kLFOCutOff_amp)
      elseif kLFOCutOff_mode == 1 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,0       ; Apply a sine waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==2 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,1       ; Apply a triangle waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==3 then
          kLFO_CutOff looptseg kLFOCutOff_freq,0,0,  1-0.5*kLFOCutOff_amp ,6,1,  1+0.5* kLFOCutOff_amp,6, 1, 1-0.5*kLFOCutOff_amp
      endif
  else
      kLFO_CutOff=1
  endif
  kCutOffLoc = kCutOffLoc*kLFO_CutOff
  ; REsonnace
  if kLFOReson_on ==1 then
      if kLFOReson_mode ==0 then
          iDur = i( kLFOReson_freq)
          kLFO_Reson linsegr 0.01, 1 / iDur , i(kLFOReson_amp),0.1, i(kLFOReson_amp)
      elseif kLFOReson_mode == 1 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,0       ; Apply a sine waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==2 then
          kResonLFO lfo  kLFOReson_amp, kLFOReson_freq,1       ; Apply a triangle waveshape
          kLFO_Reson = (kResonLFO+1)*0.5
      elseif kLFOReson_mode ==3 then
          kLFO_Reson looptseg kLFOReson_freq,0,0,  kLFOReson_amp ,6,1,  0,6, 1,   kLFOReson_amp
      endif
  else
      kLFO_Reson=1
  endif
  kResonLoc = kResonLoc*kLFO_Reson*99+1
  aOutLoc bqrez aIn,  kCutOffLoc , kResonLoc ,imode
  aOutLoc balance aOutLoc, aIn
  xout aOutLoc
endop

    
    
;--------------------------------------------
;- Region: __4: OP TONEX
;--------------------------------------------

opcode My_Tonex, a, akkkkkkkkj
 
  /*--------------------------------------------
  The filter accepts the following parameters
  --  This filter is non resonant--

  aIn                : audio signal input
  kCutOff            : Cut Off Frequency
  kPitchF_on         : If user want to follow the pitch of the input note. If yes, then CutOff frequency is unused
  kPitchF_Val        : Factor to shift the pitch follow cut off (cent() of the note. Between -2400 and + 2400, @ octaves
  kPitch             : Pitch (freq) of the note played on keyborad
  kLFOCutOff_on      : activate or not the LFO on the CutOff Frequency
  kLFOCutOff_mode    : Type of modulator for the cut Off (0 : ramp, 1: sine, 2: triangle, 3: expon segments
  kLFOCutOff_amp     : Amplitude of cut Off modulation in ]0,1]
  kLFOCutOff_freq    : Frequency of cut Off modulation in ]0,5]
  iNbFilt             :  number of layer in TONE filter
  */
 
  aIn,  kCutOff ,  kPitchF_on, kPitchF_Val, kPitch, \
  kLFOCutOff_on, kLFOCutOff_mode,kLFOCutOff_amp, kLFOCutOff_freq,iNbFilt  xin
 
  if kPitchF_on==1 then
      kCutOffLoc = kPitch * cent(kPitchF_Val)
  else
      kCutOffLoc =kCutOff
  endif

  if kLFOCutOff_on ==1 then
      if kLFOCutOff_mode ==0 then
          iDur = i( kLFOCutOff_freq)
          kLFO_CutOff linsegr 0.01, 1 / iDur , i(kLFOCutOff_amp),0.1, i(kLFOCutOff_amp)
      elseif kLFOCutOff_mode == 1 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,0       ; Apply a sine waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==2 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,1       ; Apply a triangle waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==3 then
          kLFO_CutOff looptseg kLFOCutOff_freq,0,0,   1-0.5*kLFOCutOff_amp ,6,1,  1+0.5* kLFOCutOff_amp,6, 1,  1-0.5*kLFOCutOff_amp
      endif
  else
      kLFO_CutOff=1
  endif

  kCutOffLoc = kCutOffLoc*kLFO_CutOff
  aOutLoc tonex aIn,  kCutOffLoc , iNbFilt
  xout aOutLoc
endop


;--------------------------------------------
;- Region: __5: OP ATONEX
;--------------------------------------------

opcode My_aTonex, a, akkkkkkkkj
 
  /*  See TONEX UDO for input values*/
 
  aIn,  kCutOff ,  kPitchF_on, kPitchF_Val, kPitch, \
  kLFOCutOff_on, kLFOCutOff_mode,kLFOCutOff_amp, kLFOCutOff_freq,iNbFilt  xin
 
  if kPitchF_on==1 then
      kCutOffLoc = kPitch * cent(kPitchF_Val)
  else
      kCutOffLoc =kCutOff
  endif

  if kLFOCutOff_on ==1 then
      if kLFOCutOff_mode ==0 then
          iDur = i( kLFOCutOff_freq)
          kLFO_CutOff linsegr 0.01, 1 / iDur , i(kLFOCutOff_amp),0.1, i(kLFOCutOff_amp)
      elseif kLFOCutOff_mode == 1 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,0       ; Apply a sine waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==2 then
          kCutOffLFO lfo  kLFOCutOff_amp, kLFOCutOff_freq,1       ; Apply a triangle waveshape
          kLFO_CutOff = (kCutOffLFO+2)*0.5
      elseif kLFOCutOff_mode ==3 then
          kLFO_CutOff looptseg kLFOCutOff_freq,0,0,  1-0.5*kLFOCutOff_amp ,6,1 ,  1+0.5* kLFOCutOff_amp,6, 1,   1-0.5*kLFOCutOff_amp
      endif
  else
      kLFO_CutOff=1
  endif

  kCutOffLoc = kCutOffLoc*kLFO_CutOff
  aOutLoc atonex aIn,  kCutOffLoc , iNbFilt
  xout aOutLoc
endop








;*****************************************************
;- Region: INSTRUMENTS
;*****************************************************

;- Region: INSTR  MAIN MENU
instr Main_Menu

  ;*****************************************************
  ;- Region: _1: Init Values
  ;*****************************************************

  kTrigger init 0   ;trigger used to force all groupbox to becomes visible at init time and therefore to update all values
  
  ;init the controller  -  Works with my ALESIS VI49
  kCtrler20 init 0
  kCtrler21 init 0
  kCtrler22 init 0
  ;All controler receive values between 0 and 127, but ALESIS v49 is configured to send values between 0 and 100  => easier operation
  ; The following must be adapted accordingly to your controller messages
  kCtrler20 ctrl7 1,20,0, 127
  kCtrler21 ctrl7 1,21,0, 127
  kCtrler22 ctrl7 1,22,0, 127
  kCtrler23 ctrl7 1,23,0, 127
  kCtrler24 ctrl7 1,24,0, 127
  kCtrler25 ctrl7 1,25,0, 127
  kCtrler26 ctrl7 1,26,0, 127
  kCtrler27 ctrl7 1,27,0, 127
  kCtrler28 ctrl7 1,28,0, 127
  kCtrler29 ctrl7 1,29,0, 127
  kCtrler30 ctrl7 1,30,0, 127
  kCtrler31 ctrl7 1,31,0, 127


  if  kTrigger==0 then                              ; only for init time : set all groupbox visible
      chnset "visible(0)","GB_Effects"
      chnset "visible(0)","GB_ADSR"
      chnset "visible(0)","GB_Filters"
      chnset "visible(1)","GB_MainOsc"
      gkFl_GB_Effect = 1                          ; force to enter each instrument to  calculate initial values
      gkFl_GB_Env = 1
      gkFl_GB_Filt = 1
      gkFl_GB_Osc = 1
      kTrigger =1                                 ; will never be used again
  else
 
      ;--------------------------------------------
      ;- Region: _2:  Management of Menu Buttons
      ;--------------------------------------------
      if changed:k(chnget:k("But_Call_MainOsc"))==1  || changed:k(chnget:k("But_Call_ADSR"))==1 || \                 ; show groupbox depending on selected button
          changed:k(chnget:k("But_Call_Filters"))==1 || changed:k(chnget:k("But_Call_Effects"))==1 then
          if chnget:k("But_Call_MainOsc")==1 then
              chnset "visible(0)","GB_Effects"
              chnset "visible(0)","GB_ADSR"
              chnset "visible(0)","GB_Filters"
              chnset "visible(1)","GB_MainOsc"
              gkFl_GB_Env = 0
              gkFl_GB_Effect = 0
              gkFl_GB_Filt = 0
              gkFl_GB_Osc = 1
          elseif chnget:k("But_Call_ADSR")==1 then
              chnset "visible(0)","GB_Effects"
              chnset "visible(0)", "GB_MainOsc"
              chnset "visible(0)","GB_Filters"
              chnset "visible(1)","GB_ADSR"
              gkFl_GB_Effect = 0
              gkFl_GB_Filt = 0
              gkFl_GB_Osc = 0
              gkFl_GB_Env = 1
          elseif chnget:k("But_Call_Filters")==1 then
              chnset "visible(0)","GB_Effects"
              chnset "visible(0)", "GB_MainOsc"
              chnset "visible(0)", "GB_ADSR"
              chnset "visible(1)","GB_Filters"
              gkFl_GB_Env = 0
              gkFl_GB_Effect = 0
              gkFl_GB_Osc = 0
              gkFl_GB_Filt = 1
          elseif chnget:k("But_Call_Effects")==1 then
              chnset "visible(0)", "GB_Filters"
              chnset "visible(0)", "GB_MainOsc"
              chnset "visible(0)", "GB_ADSR"
              chnset "visible(1)","GB_Effects"
              gkFl_GB_Env = 0
              gkFl_GB_Osc = 0
              gkFl_GB_Filt = 0
              gkFl_GB_Effect = 1
          endif
      endif
  endif  ; if  ktrigger  ==0 then



  ;--------------------------------------
  ;- Region: _3: Button PANIC
  ; Turn off and on all instruments
  ;--------------------------------------

  if changed:k(chnget:k("But_Call_Panic"))==1 then
      if chnget:k("But_Call_Panic")==1 then
          turnoff2 "Echo",0,0
          turnoff2 "Reverb",0,0
          turnoff2 1,0,0
          ; reinit TURNON
          if gkReverb_On==1 then
              event "i","Reverb",0.5,-3600
          endif
          if gkEcho_On==1 then
              event "i","Echo",0.5,-3600
          endif
      endif
  endif
  
  ;--------------------------------------
  ;- Region: _4: Preset_Combo
  ;--------------------------------------
  if changed:k(chnget:k("PresetCombo"))==1 then
      kEcho_active active "Echo",0,1
      if kEcho_active==1 then
          chnclear "Echo_SendL"
          chnclear "Echo_SendR"
      endif
      kReverb_active active "Reverb",0,1
      if kReverb_active==1 then
          chnclear "Reverb_SendL"
          chnclear "Reverb_SendR"
      endif
      kInstr1_active active 1,0,1
    ;  if kInstr1_active==1 then
    ;      turnoff2 1,0,0
    ;  endif
      event	"i", "LoadSoundFile", 0, 0, 1
      event	"i", "LoadSoundFile", 0, 0, 2
      event	"i", "LoadSoundFile", 0, 0, 3
      kTrigger =0
      chnset k(1),"But_Call_MainOsc"
  endif




  ;---------------------------------------
  ;- Region: _5: Real Knobs Ctroller
  ;---------------------------------------
  if changed(kCtrler20)== 1  then
      gkFreq_Morph = kCtrler20*0.05
      chnset gkFreq_Morph,"Enc_Freq_Morph"
  endif
  if changed(kCtrler21)== 1 || changed(kCtrler22)== 1 then    ;read and rescale the Ctr 20 (unites)  and 21 (decimales)
      ;messages from controllers are between 0 and 100   (using a config from the alesis vi49)
      gkEnc_Freq_Mod= kCtrler21*.05 +kCtrler22*0.005
      chnset gkEnc_Freq_Mod,"Enc_Freq_Mod"
  endif
      
  if changed(kCtrler23)== 1  then
      gkEnc_Amp_Mod = kCtrler23*0.25
      chnset gkEnc_Amp_Mod,"Enc_Amp_Mod"
  endif
  if changed(kCtrler24)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler25)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler26)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler27)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler28)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler29)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler30)== 1  then
      ; Not implemented yet
  endif
  if changed(kCtrler31)== 1  then
      gkMainGain =  kCtrler31*0.01
      chnset gkMainGain,"MainGain"
  endif
      
endin
    
      
      
      
      
      
;**********************************************
;- Region: INSTR  GROUPBOXES
;**********************************************

              
instr Manage_Groupbox

  /*

  Depending on the values  0 or 1 of the following flags
  gkFl_GB_Env
  gkFl_GB_Effect
  gkFl_GB_Osc
  gkFl_GB_Filt
  which is set by clicking on the menu buttons, Enter of skip the management of the groupboxes.
  This allows managing only the visible  groupbox and doing nothing with the others (user can only interact with visible groupbox)

  if gkFl_GB_Osc ==1 then
      ;;; MANAGE GROUPBOX Osci
  endif
  if gkFl_GB_Env ==1 then
      ;;; MANAGE GROUPBOX Enveloppe
  endif


  etc...

  */


  ;----------------------------------------
  ;- Region: _1: OSC GROUPBOX
                              
  if gkFl_GB_Osc == 1 then
      ;----------------------------------------
      ;- Region: __1: Morphing widget
      ; Get the frequence for morphing sound
    
      if changed:k(chnget:k("Enc_Freq_Morph"))==1 then
          gkFreq_Morph chnget  "Enc_Freq_Morph"
          if chnget:k("HostSlave_On") ==1 then
              gkFreq_Morph = gkFreq_Morph*gkTempoFactor/60
          endif
      endif
      ; Get the shape of the  morphing
      if changed:k(chnget:k("ChkBox_Sin"))==1 || changed:k(chnget:k("ChkBox_Exp"))==1 || changed:k(chnget:k("ChkBox_Seg"))==1 || changed:k(chnget:k("ChkBox_Line"))==1 then
          if chnget:k("ChkBox_Sin")==1 then
              gkFlagMorph=1
          elseif chnget:k("ChkBox_Seg")==1 then
              gkFlagMorph=2
          elseif chnget:k("ChkBox_Exp")==1 then
              gkFlagMorph=3
          elseif chnget:k("ChkBox_Line")==1 then
              gkFlagMorph=4
          endif
      endif

      ;---------------------------
      ;- Region: __2: Suboscil widget
      if changed:k(chnget:k("OscA_SubOsc"))==1 then
          gkOscA_SubOsc  chnget  "OscA_SubOsc"
      endif
      if changed:k(chnget:k("OscA_SubOsc_Mix"))==1 then
          gkOscA_SubOsc_Mix  chnget "OscA_SubOsc_Mix"
      endif
  
  
      ;---------------------------
      ;- Region: __3: FM  
      
      if changed:k(chnget:k( "Enc_Freq_Mod"))==1 then
          gkEnc_Freq_Mod chnget  "Enc_Freq_Mod"
      endif
      if changed:k(chnget:k("Enc_Amp_Mod"))==1 then
          gkEnc_Amp_Mod  chnget  "Enc_Amp_Mod"
      endif


      ;-----------------------------------------------------------------
      ;- Region: __4: Load soundfile buttons
      
      if changed:k(chnget:S("filenameOscA"))==1 then
          gSfilepathOscA	    chnget	"filenameOscA"
      endif
      if changed:k(chnget:S("filenameOscB"))==1 then
          gSfilepathOscB	    chnget	"filenameOscB"
      endif
      if changed:k(chnget:S("filenameOscC"))==1 then
          gSfilepathOscC	    chnget	"filenameOscC"
      endif 
      kNewFileTrg1  changed	gSfilepathOscA	    ; if a new file is loaded generate a trigger
      kNewFileTrg2  changed	gSfilepathOscB	    ; if a new file is loaded generate a trigger
      kNewFileTrg3  changed	gSfilepathOscC	    ; if a new file is loaded generate a trigger
      if kNewFileTrg1 == 1 then		; if user has requested a preset or new file...
          event	"i", "LoadSoundFile", 0, 0, 1      
      endif   
      if kNewFileTrg2 == 1 then		; if user has requested a preset or new file...
          event	"i", "LoadSoundFile", 0, 0, 2       
      endif 
      if kNewFileTrg3 == 1 then		; if user has requested a preset or new file...
          event	"i", "LoadSoundFile", 0, 0, 3
      endif  
  endif  ; if if gkFl_GB_Osc == 1 then



  ;----------------------------------------
  ;- Region: _2: ENV GROUPBOX
 
  if gkFl_GB_Env == 1 then

      ;-----------------------------------------------------------------
      ;-  __1: Enveloppe GUI management
      if changed:k(chnget:k("ChkBox_ADSR_AD"))==1 || changed:k(chnget:k("ChkBox_ADSR_ADSR"))==1 \
          || changed:k(chnget:k("ChkBox_ADSR_EXPADSR"))==1 || changed:k(chnget:k("ChkBox_ADSR_REV"))==1 then
          if chnget:k("ChkBox_ADSR_AD")==1 then
              gkADSR_Mod =1
              chnset "active(0)", "R_Enc_ADSR_Sustain"
              chnset "active(0)", "R_Enc_ADSR_Release"
              chnset "active(1)", "R_Enc_ADSR_Decay"
          elseif chnget:k("ChkBox_ADSR_ADSR")==1  then
              gkADSR_Mod =2
              chnset "active(1)", "R_Enc_ADSR_Sustain"
              chnset "active(1)", "R_Enc_ADSR_Release"
              chnset "active(1)", "R_Enc_ADSR_Decay"
          elseif chnget:k("ChkBox_ADSR_EXPADSR")==1 then
              gkADSR_Mod =3
              chnset "active(1)", "R_Enc_ADSR_Sustain"
              chnset "active(1)", "R_Enc_ADSR_Release"
              chnset "active(1)", "R_Enc_ADSR_Decay"
          elseif chnget:k("ChkBox_ADSR_REV")==1 then
              gkADSR_Mod =4
              chnset "active(0)", "R_Enc_ADSR_Decay"
              chnset "active(1)", "R_Enc_ADSR_Sustain"
              chnset "active(1)", "R_Enc_ADSR_Release"
          endif
      endif
      if changed:k(chnget:k("Enc_ADSR_Attack"))==1 then
          gkADSR_Attack= chnget:k("Enc_ADSR_Attack")
      endif
      if changed:k(chnget:k("Enc_ADSR_Decay"))==1 then
          gkADSR_Decay= chnget:k("Enc_ADSR_Decay")
      endif
      if changed:k(chnget:k("Enc_ADSR_Sustain"))==1 then
          gkADSR_Sustain= chnget:k("Enc_ADSR_Sustain")
      endif
      if changed:k(chnget:k("Enc_ADSR_Release"))==1 then
          gkADSR_Release= chnget:k("Enc_ADSR_Release")
      endif
  endif  ;   if gkFl_GB_Env == 1 then



  ;----------------------------------------
  ;- Region: _3: FILTER GROUPBOX
  if gkFl_GB_Filt == 1 then
      ;- Region:  __Check if filter is on
      if changed:k(chnget:k("ChkBox_Filter_On"))==1 then
          if chnget:k("ChkBox_Filter_On")==1 then
              gkFilter_is_On = 1
          else
              gkFilter_is_On = 0
          endif
      endif

      ;- Region:  __Check selected filter type
      if changed:k(chnget:k("ChkBox_Filter_Moogl"))==1 || changed:k(chnget:k("ChkBox_Filter_LPF18"))==1  ||changed:k(chnget:k("ChkBox_Filter_BQRez"))==1  \
          ||  changed:k(chnget:k("ChkBox_Filter_Tone"))==1  || changed:k(chnget:k("ChkBox_Filter_aTone"))==1 then
           
          if   chnget:k("ChkBox_Filter_Moogl")==1 then
              gkFilter_Type=0
              chnset "active(0)", "R_Enc_Filter_Distor"
              chnset "active(1)", "R_Enc_Filter_Reson"
              chnset "active(0)", "R_Combo_Filter_BQRez"
              chnset "active(1)", "R_Enc_Filter_CutOff"
          elseif   chnget:k("ChkBox_Filter_LPF18")==1 then
              gkFilter_Type=1
              chnset "active(1)", "R_Enc_Filter_Reson"
              chnset "active(1)", "R_Enc_Filter_Distor"
              chnset "active(0)", "R_Combo_Filter_BQRez"
              chnset "active(1)", "R_Enc_Filter_CutOff"
          elseif   chnget:k("ChkBox_Filter_BQRez")==1 then
              gkFilter_Type=2
              chnset "active(1)", "R_Enc_Filter_Reson"
              chnset "active(0)", "R_Enc_Filter_Distor"
              chnset "active(1)", "R_Combo_Filter_BQRez"
              chnset "active(1)", "R_Enc_Filter_CutOff"
          elseif   chnget:k("ChkBox_Filter_Tone")==1 then
              gkFilter_Type=3
              chnset "active(0)", "R_Enc_Filter_Reson"
              chnset "active(0)", "R_Enc_Filter_Distor"
              chnset "active(0)", "R_Combo_Filter_BQRez"
              chnset "active(1)", "R_Enc_Filter_CutOff"
          elseif   chnget:k("ChkBox_Filter_aTone")==1 then
              gkFilter_Type=4
              chnset "active(0)", "R_Enc_Filter_Reson"
              chnset "active(0)", "R_Enc_Filter_Distor"
              chnset "active(0)", "R_Combo_Filter_BQRez"
              chnset "active(1)", "R_Enc_Filter_CutOff"
          endif
      endif

      ;- Region:  __Get values Main Encoders
      if changed:k(chnget:k("Enc_Filter_Mix"))==1 then
          gkFilter_Mix = chnget:k("Enc_Filter_Mix")
      endif

      if changed:k(chnget:k("Enc_Filter_CutOff"))==1 then
          gkFilter_CutOff = chnget:k("Enc_Filter_CutOff")
      endif

      if changed:k(chnget:k("Enc_Filter_Reson"))==1 then
          gkFilter_Reson = chnget:k("Enc_Filter_Reson")
      endif

      if changed:k(chnget:k("Enc_Filter_Distor"))==1 then
          gkFilter_Distor = chnget:k("Enc_Filter_Distor")
      endif

      ;- Region:  __Get values BQrez combo
      if changed:k(chnget:k("Combo_Filter_BQRez"))==1 then
          kFilterCombo = chnget:k("Combo_Filter_BQRez")
          reinit REINIT_BQREZ
          REINIT_BQREZ:
              giBQrez_Type = i(kFilterCombo)-1
          rireturn
      endif
      ;- Region:  __Get values Tone/atone sliders
      if changed:k(chnget:k("Slider_Filter_Tonelayer"))==1 then
          kLayer = chnget:k("Slider_Filter_Tonelayer")
          reinit TONE_LAYER
          TONE_LAYER:
              giToneLayer = i(kLayer)
          rireturn
      endif
      if changed:k(chnget:k("Slider_Filter_aTonelayer"))==1 then
          kLayer = chnget:k("Slider_Filter_aTonelayer")
          reinit ATONE_LAYER
          ATONE_LAYER:
              giAToneLayer = i(kLayer)
          rireturn
      endif

      ;- Region:  __Get values Filter Pitch Follow
      if changed:k(chnget:k("ChkBox_Filter_PitchFollowOn"))==1 then
          if chnget:k("ChkBox_Filter_PitchFollowOn")== 1 then
              gkFilter_PitchFollow=1
          else
              gkFilter_PitchFollow=0
          endif
      endif
      if  gkFilter_PitchFollow==1  && changed:k(chnget:k("Enc_Filter_Follow"))==1 then
          gkFilter_PitchFollow_Value = chnget:k("Enc_Filter_Follow")
      endif

      ;- Region:  __Get values LFO Cut Off
      if changed:k(chnget:k("ChkBox_Filter_CutOff_LFO_On"))==1 then
          if chnget:k("ChkBox_Filter_CutOff_LFO_On")==1 then
              gkFilter_CutOff_LFO_is_On = 1
          else
              gkFilter_CutOff_LFO_is_On = 0
          endif
      endif
      if gkFilter_CutOff_LFO_is_On ==1 then
          if changed:k(chnget:k("Enc_Filter_CutOff_Amp"))==1 then
              gkFilter_CutOff_Amp = chnget:k("Enc_Filter_CutOff_Amp")
          endif
          if changed:k(chnget:k("Enc_Filter_CutOff_Freq"))==1 then
              gkFilter_CutOff_Freq = chnget:k("Enc_Filter_CutOff_Freq")
          endif
          if changed:k(chnget:k("ChkBox_Filter_CutOff_Line"))==1  || changed:k(chnget:k("ChkBox_Filter_CutOff_Sine"))==1 || \
              changed:k(chnget:k("ChkBox_Filter_CutOff_Seg"))==1 || changed:k(chnget:k("ChkBox_Filter_CutOff_Exp"))==1 then
              if chnget:k("ChkBox_Filter_CutOff_Line")==1     then
                  gkFilter_CutOff_LFO_Mode = 0
              elseif chnget:k("ChkBox_Filter_CutOff_Sine")==1 then
                  gkFilter_CutOff_LFO_Mode = 1
              elseif chnget:k("ChkBox_Filter_CutOff_Seg")==1  then
                  gkFilter_CutOff_LFO_Mode = 2
              elseif chnget:k("ChkBox_Filter_CutOff_Exp")==1  then
                  gkFilter_CutOff_LFO_Mode = 3
              endif
          endif
      endif

      ;- Region:  __Get values LFO Resonance
      if changed:k(chnget:k("ChkBox_Filter_Reson_LFO_On"))==1 then
          if chnget:k("ChkBox_Filter_Reson_LFO_On")==1 then
              gkFilter_Reson_LFO_is_On = 1
          else
              gkFilter_Reson_LFO_is_On = 0
          endif
      endif
      if gkFilter_Reson_LFO_is_On ==1 then
          if changed:k(chnget:k("Enc_Filter_Reson_Amp"))==1 then
              gkFilter_Reson_Amp = chnget:k("Enc_Filter_Reson_Amp")
          endif
          if changed:k(chnget:k("Enc_Filter_Reson_Freq"))==1 then
              gkFilter_Reson_Freq = chnget:k("Enc_Filter_Reson_Freq")
          endif
          if changed:k(chnget:k("ChkBox_Filter_Reson_Line"))==1  || changed:k(chnget:k("ChkBox_Filter_Reson_Sine"))==1 || \
              changed:k(chnget:k("ChkBox_Filter_Reson_Seg"))==1 || changed:k(chnget:k("ChkBox_Filter_Reson_Exp"))==1 then
              if chnget:k("ChkBox_Filter_Reson_Line")==1     then
                  gkFilter_Reson_LFO_Mode = 0
              elseif chnget:k("ChkBox_Filter_Reson_Sine")==1 then
                  gkFilter_Reson_LFO_Mode = 1
              elseif chnget:k("ChkBox_Filter_Reson_Seg")==1  then
                  gkFilter_Reson_LFO_Mode = 2
              elseif chnget:k("ChkBox_Filter_Reson_Exp")==1  then
                  gkFilter_Reson_LFO_Mode = 3
              endif
          endif
      endif

      ;- Region:  __Get values Filter Audio ADSR
      if changed:k(chnget:k("ChkBox_Filter_Env_On"))==1 then
          if chnget:k("ChkBox_Filter_Env_On")==1 then
              gkFilter_Env_is_On=1
          else
              gkFilter_Env_is_On=0
          endif
      endif
      if gkFilter_Env_is_On==1 then
          if changed:k(chnget:k("Enc_Filter_Env_Att"))==1 then
              gkFilter_Env_Att=  chnget:k("Enc_Filter_Env_Att")
          endif
          if changed:k(chnget:k("Enc_Filter_Env_Dec"))==1 then
              gkFilter_Env_Dec=  chnget:k("Enc_Filter_Env_Dec")
          endif
          if changed:k(chnget:k("Enc_Filter_Env_Sus"))==1 then
              gkFilter_Env_Sus=  chnget:k("Enc_Filter_Env_Sus")
          endif
          if changed:k(chnget:k("Enc_Filter_Env_Rel"))==1 then
              gkFilter_Env_Rel=  chnget:k("Enc_Filter_Env_Rel")
          endif
      endif
  endif   ; Groupbox filter


 
  ;----------------------------------------
  ;- Region: _4: EFFECTS GROUPBOX

  if gkFl_GB_Effect == 1 then
 
      ;- Region: Effect management
      ;- Region: __1-Reverb
      if changed:k(chnget:k("Reverb_On"))==1 then
          kReverb_actve active "Echo",0,1
          if chnget:k("Reverb_On")==1 then
              gkReverb_On =1
              if kReverb_actve==0 then
                  event "i","Reverb",0,-3600
              endif
          else
              gkReverb_On =0
              if kReverb_actve==1 then
                  turnoff2 "Reverb",0,0
              endif
              ;  turnoff2 "Echo",0,1
              ;  chnclear "Echo_Send"
          endif
      endif
      if changed:k(chnget:k("Reverb_Room"))==1 then
          gkReverb_Room=chnget:k("Reverb_Room")
      endif
      if changed:k(chnget:k("Reverb_Damp"))==1 then
          gkReverb_Damp =chnget:k("Reverb_Damp")
      endif
      if changed:k(chnget:k("Reverb_Mix"))==1 then
          gkReverb_Mix =chnget:k("Reverb_Mix")
      endif
 
      ;- Region: __2-Echo
      if changed:k(chnget:k("Echo_On"))==1 then
          kEcho_actve active "Echo",0,1
          if chnget:k("Echo_On")==1 then
              gkEcho_On =1
              if kEcho_actve==0 then
                  event "i","Echo",0,-3600
              endif
          else
              if kEcho_actve==1 then
                  turnoff2 "Echo",0,0
              endif
              gkEcho_On =0
          endif
      endif
      if changed:k(chnget:k("Echo_Delay"))==1 then
          gkEcho_rvt = chnget:k("Echo_Delay")
      endif
      if changed:k(chnget:k("Echo_Loop"))==1 then
          gkEcho_loop = chnget:k("Echo_Loop")
      endif
   
      ;- Region: __3-Ring Modulation
      if changed:k(chnget:k("Ring_On"))==1 then
          if chnget:k("Ring_On")==1 then
              gkRing_On=1
          else
              gkRing_On=0
          endif
      endif
      if changed:k(chnget:k("Ring_Amp"))==1 then
          gkRing_Amp=chnget:k("Ring_Amp")
      endif
      if changed:k(chnget:k("Ring_Freq"))==1 then
          gkRing_Freq= chnget:k("Ring_Freq")
      endif
      if changed:k(chnget:k("Ring_Offset"))==1 then
          gkRing_Offset=chnget:k("Ring_Offset")
      endif
      
      ;- Region: __4-Flanger
      if changed:k(chnget:k("Flanger_On"))==1 then
          if chnget:k("Flanger_On")==1 then
              gkFlanger_On=1
          else
              gkFlanger_On=0
          endif
      endif
      if changed:k(chnget:k("Flanger_Depth"))==1 then
          gkFlanger_Depth= chnget:k("Flanger_Depth")
      endif
      if changed:k(chnget:k("Flanger_Freq"))==1 then
          gkFlanger_Freq = chnget:k("Flanger_Freq")
      endif
      if changed:k(chnget:k("Flanger_FeedBack"))==1 then
          gkFlanger_FeedBack = chnget:k("Flanger_FeedBack")
      endif

      ;- Region: __5-Chorus
      if changed:k(chnget:k("Chorus_On"))==1 then
          if chnget:k("Chorus_On")==1 then
              gkChorus_On=1
          else
              gkChorus_On=0
          endif
      endif
      if gkChorus_On==1 then
          if changed:k(chnget:k("Chorus_Min"))==1 then
              gkChorus_Min= chnget:k("Chorus_Min")
              gkChorus_Min = gkChorus_Min/1000
          endif
          if changed:k(chnget:k("Chorus_Rate"))==1 then
              gkChorus_Rate= chnget:k("Chorus_Rate")
          endif
          if changed:k(chnget:k("Chorus_Max"))==1 then
              gkChorus_Max = chnget:k("Chorus_Max")
              gkChorus_Max= gkChorus_Max/1000
          endif
          if changed:k(chnget:k("Chorus_Mix"))==1 then
              gkChorus_Mix = chnget:k("Chorus_Mix")
          endif
      endif
  
      ;- Region: __6-Main Gain
      if changed:k(chnget:k("MainGain"))==1 then
          gkMainGain = chnget:k("MainGain")
      endif
 
      ;- Region: __7-Host Enslave
      if chnget:k("HostSlave_On")==1 then
          if chnget:k("IS_A_PLUGIN")==1 then
              gkTempoFactor= chnget:k("HOST_BPM")
              chnset gkTempoFactor,"HostBPMValue"
              chnset gkFreq_Morph,"HostMorphValue"
          else
              gkTempoFactor = 1
              chnset gkTempoFactor,"HostBPMValue"
              chnset gkFreq_Morph,"HostMorphValue"
          endif
      else
          gkTempoFactor = 1
          chnset gkTempoFactor,"HostBPMValue"
          chnset gkFreq_Morph,"HostMorphValue"
      endif
      
      ;- Region: __8-BinAural
      if changed:k(chnget:k("ChkBox_Binaural"))==1 then
          gkStereo chnget ("ChkBox_Binaural")
          printks "gkstero : %d \n",0,gkStereo
      endif
      if changed:k(chnget:k("Enc_Azimut"))==1 then
          kToto = chnget:k("Enc_Azimut")
          gkaz =kToto
          reinit AZIMUT
      endif

      if changed:k(chnget:k("Enc_Elev"))==1 then
          kToto1 = chnget:k("Enc_Elev")
          gkel = kToto1
          reinit ELEVATION
      endif
  endif

  AZIMUT:
      giAz = i(kToto)
  rireturn

  ELEVATION:
      giElev = i(kToto1)
  rireturn
endin



instr	LoadSoundFile	; load sound file

  if p4 == 1 then
      ;     Sfile strcpy gSfilepathOscA
      if filevalid(gSfilepathOscA) ==1 then
          ;  gitableOscA	ftgen	-901,0,0,1,SFilePath,0,0,0	; deallocate table first
          gitableOscA	ftgen	901,0,0,1,gSfilepathOscA,0,0,0		; load sound file into a GEN 01 function table
          gichansOscA	filenchnls	gSfilepathOscA			; derive the number of channels (mono=1,stereo=2) in the sound file
          giReadyOscA 	=	1					; if no string has yet been loaded giReady will be zero
          gkTabLenOscA	init		ftlen(gitableOscA)/gichansOscA		; table length in sample frames
          Smessage sprintfk "file(%s)", gSfilepathOscA			; print sound file to viewer
          chnset Smessage, "filerOscA"
      else
          printks "File no valid \n",0
      endif
  elseif p4 == 2 then
      ;  Sfile strcpy gSfilepathOscB
      if filevalid(gSfilepathOscB) ==1 then
          ; gitableOscB	ftgen	-902,0,0,1,SFilePath,0,0,0
          gitableOscB	ftgen	902,0,0,1,gSfilepathOscB,0,0,0		; load sound file into a GEN 01 function table
          gichansOscB	filenchnls	gSfilepathOscB			; derive the number of channels (mono=1,stereo=2) in the sound file
          giReadyOscB 	=	1					; if no string has yet been loaded giReady will be zero
          gkTabLenOscB	init		ftlen(gitableOscB)/gichansOscB		; table length in sample frames
          Smessage sprintfk "file(%s)", gSfilepathOscB			; print sound file to viewer
          chnset Smessage, "filerOscB"
      endif
  elseif p4 == 3 then
      ;  Sfile strcpy gSfilepathOscB
      if filevalid(gSfilepathOscC) ==1 then
          ;   gitableOscC	ftgen	-903,0,0,1,SFilePath,0,0,0
          gitableOscC	ftgen	903,0,0,1,gSfilepathOscC,0,0,0		; load sound file into a GEN 01 function table
          gichansOscC filenchnls	gSfilepathOscC			; derive the number of channels (mono=1,stereo=2) in the sound file
          giReadyOscC 	=	1					; if no string has yet been loaded giReady will be zero
          gkTabLenOscC	init		ftlen(gitableOscC)/gichansOscC		; table length in sample frames
          Smessage sprintfk "file(%s)", gSfilepathOscC			; print sound file to viewer
          chnset Smessage, "filerOscC"
      endif
  endif
endin




instr Echo
  aInL chnget "Echo_SendL"
  aInR chnget "Echo_SendR"
  if  gkEcho_On==1 then
      aOutL vcomb aInL, gkEcho_rvt, gkEcho_loop, 6
      aOutR vcomb aInR, gkEcho_rvt, gkEcho_loop, 6
  
      if gkReverb_On==1 then
          chnmix aOutL*gkReverb_Mix,"Reverb_SendL"
          chnmix aOutR*gkReverb_Mix,"Reverb_SendR"
      endif
  endif
  outs aOutL,aOutR
  chnclear "Echo_SendL"
  chnclear "Echo_SendR"
endin



instr  Reverb    ; Reverb
  aInL chnget "Reverb_SendL"
  aInR chnget "Reverb_SendR"
  ; create reverberated version of input signal (note stereo input and output)
  aRvbL,aRvbR  freeverb aInL,  aInR, gkReverb_Room, gkReverb_Damp
  outs      aRvbL, aRvbR ; send audio to outputs
  chnclear "Reverb_SendL"
  chnclear "Reverb_SendR"
endin




instr InitData
  ; SPresetPath init "AKWF_sin_0001.wav"
  gSstereoL sprintf "%s/%s", chnget:S("CSD_PATH"), "hrtf-44100-left.dat"
  gSstereoR sprintf "%s/%s", chnget:S("CSD_PATH"), "hrtf-44100-right.dat"
  gSfilepathOscA sprintf "%s/%s", chnget:S("CSD_PATH"), "AKWF_saw.wav"
  gSfilepathOscB sprintf "%s/%s", chnget:S("CSD_PATH"), "AKWF_tri.wav"
  gSfilepathOscC sprintf "%s/%s", chnget:S("CSD_PATH"), "AKWF_sin.wav"
  prints gSfilepathOscC
  event	"i", "LoadSoundFile", 0, 0, 1
  event	"i", "LoadSoundFile", 0, 0, 2
  event	"i", "LoadSoundFile", 0, 0, 3
  ; chnset SFilepath, "filenameOscC"
  ; prints SFilepath
endin





instr	800 ; This instrument gets all midi message for bank changing and aftertouch

  gkAftouch=0
  kstatus,kchan,kdata1,kdata2 midiin
  if kstatus==208 then
      gkAfttch = kdata1/127 ; between 0 and 1
      ; printks2 "gkmod %f \n",gkAftouch
      ;  printks "kstatus %d    kchan %d    aft : %d    data2 %d   Myaft %f\n",0,kstatus,kchan,kdata1,kdata2,gkAftouch
  endif
  if (kstatus == 128)  then
      gkAfttch=0
  endif
  if (kstatus == 192)  then  ; program change
      ; printks "kstatus %d    kchan %d    aft : %d    data2 %d   Myaft %f\n",0,kstatus,kchan,kdata1,kdata2,gkAftouch
      chnset kdata1,"PresetCombo"
  endif
endin




instr 801
/* Init all audio signal at 0.. sure they existg */
aleft init 0 
aright init 0 
aRing init 0 
aoscil init 0 
aOut1 init 0 
aOut2 init 0 
aOut init 0 
aoscilSub init 0 
aOutSub1 init 0 
aOutSub2 init 0 
aOutSub init 0 

  kmod_frq init 0
  kmod_amp init 0
  kamp init 0
  kAftPitch init 0
  kPchBnd init 0
  kPitchInit init 0
  kweightpoint init 0
  kSubPitch init 0
  kVolume_Envelope init 0


  ;instrument will be triggered by keyboard widget

  kamp =p5/127
  ival init 1

  ; -- aftertouch --
   if gkAfttch!=0 then 
        kAftPitch lfo gkAfttch,8*gkAfttch   ; get the value of gkAfttch  from instr 800
   else
        kAftPitch=0
   endif
  ;printks  "aft : %f \n",0.2,kAfttch
      
  ; -- pitch bend --
  kPchBnd  pchbend  0,12                ; read in pitch bend (range -6 to 6)

  ; MIDI note number + pitch bend are converted to cycles per seconds
  kPitchInit = cpsmidinn(p4+kPchBnd+kAftPitch)

;prints "FreqMorph %f\n ", gkFreq_Morph
;prints "\n\n"
  ;-----------------------------------------
  ;- Region: _Calculate Audio signal
  ;- Region: ______With FM
  ;IF  THERE IS FM
  if gkEnc_Freq_Mod > 0 then
  ;  prints "FM ON    "
      kmod_frq    = kPitchInit    * gkEnc_Freq_Mod
      kmod_amp    = kmod_frq * gkEnc_Amp_Mod
      aoscil      poscil kmod_amp, kmod_frq, gitableOscC                                 ;  FM : create the  oscillator for the modulator
      ;IF THERE IS MORPHING
      if gkFreq_Morph >0 then    
        ;  prints "          MORPH ON "; if Freq for morphing is NOT 0  then
          ;- Region: ;- Region: ________With Morphing
          if gkFlagMorph==1 then                                                              ; calculate the curve for morphing depending on choice
              kweightpoint lfo 1, gkFreq_Morph
              kweightpoint= (kweightpoint+1)/2
          elseif gkFlagMorph==2 then
              kweightpoint loopseg gkFreq_Morph,0, 0.0,0.0,  1.0, 1,  2.0, 0
          elseif gkFlagMorph==3 then
              kweightpoint looptseg gkFreq_Morph,0,0,            0,6,1,   1,6, 1,   0
          elseif gkFlagMorph==4 then
              kweightpoint linsegr 0, i(gkFreq_Morph),1,1,1
          endif
          aOut1 poscil kweightpoint,	kPitchInit + aoscil ,gitableOscB
          aOut2 poscil (1-kweightpoint),	kPitchInit + aoscil ,gitableOscA
          aOut sum aOut1,aOut2
          ;IF THERE IS SUBOSCIL
          if gkOscA_SubOsc!=0 then
       ;     prints "                       SUB ON "; if Freq for morphing is NOT 0  then
              kSubPitch  =kPitchInit *octave(gkOscA_SubOsc)
              aoscilSub poscil kmod_amp, kmod_frq*octave(gkOscA_SubOsc),gitableOscC     ;calculate the FM audio signal to modulate Subosc
              aOutSub1 poscil kweightpoint,	kSubPitch + aoscilSub ,gitableOscB
              aOutSub2 poscil (1-kweightpoint),	kSubPitch + aoscilSub ,gitableOscA
              aOutSub sum aOutSub1,aOutSub2
              aOut sum  aOut*(1-gkOscA_SubOsc_Mix),aOutSub*gkOscA_SubOsc_Mix
          endif
          aOut = aOut * kamp
      else
          ;ELSE THERE IS NO MORPHING
     ;     prints "          MORPH OFF ";
          ;- Region: ________Without Morphing
          aOut1 poscil kamp,kPitchInit + aoscil,gitableOscB
          aOut2 poscil kamp,kPitchInit + aoscil,gitableOscA
          aOut sum aOut1 , aOut2
          ;IF THERE IS SUBOSCIL
          ;- Region: ________With SubOscil
          if gkOscA_SubOsc >=0 then
       ;         prints "                       SUB ON ";
              kSubPitch= kPitchInit *octave(gkOscA_SubOsc)
              aoscilSub poscil kmod_amp, kmod_frq*octave(gkOscA_SubOsc),gitableOscC     ;calculate the FM audio signal to modulate Subosc
              aOutSub1 poscil kamp,kSubPitch +aoscilSub,gitableOscB
              aOutSub2 poscil kamp,kSubPitch +aoscilSub,gitableOscA
              aOutSub sum aOutSub1, aOutSub2
              aOut sum aOut*(1-gkOscA_SubOsc_Mix), aOutSub*gkOscA_SubOsc_Mix
          endif
         ; aOut = aOut * kamp
      endif
			
;prints "\n"
      ;---------------------------------
      ;- Region: ______Without FM
      ;ELSE THERE IS NO FM
  else
      ;IF THERE IS MORPHING
     ; prints "FM OFF    "
      if gkFreq_Morph > 0 then                                                          ; if Freq for morphing is NOT 0  then
          ;- Region: ________With Morphing
         ; prints "          MORPH ON "
          if gkFlagMorph==1 then                                                              ; calculate the curve for morphing depending on choice
              kweightpoint lfo 1, gkFreq_Morph
              kweightpoint= (kweightpoint+1)/2
          elseif gkFlagMorph==2 then
              kweightpoint loopseg gkFreq_Morph,0, 0.0,0.0,  1.0, 1,  2.0, 0
          elseif gkFlagMorph==3 then
              kweightpoint looptseg gkFreq_Morph,0,0,            0,6,1,   1,6, 1,   0
          elseif gkFlagMorph==4 then
              kweightpoint linsegr 0, i(gkFreq_Morph),1,1,1
          endif
          aOut1 poscil kweightpoint,    	kPitchInit ,gitableOscB
          aOut2 poscil (1-kweightpoint),	kPitchInit ,gitableOscA
          aOut sum aOut1,aOut2
          ;IF THERE IS SUBOSCIL
          if gkOscA_SubOsc >=0 then
              kSubPitch= kPitchInit *octave(gkOscA_SubOsc)
              aOutSub1 poscil kweightpoint    ,kSubPitch, gitableOscB
              aOutSub2 poscil (1-kweightpoint),kSubPitch, gitableOscA
              aOutSub sum aOutSub1, aOutSub2
              aOut sum aOut*(1-gkOscA_SubOsc_Mix), aOutSub*gkOscA_SubOsc_Mix
              ;ENDIF
          endif
          aOut = aOut * kamp
      else
          ;- Region: _______ _Without Morphing
          ;ELSE THERE IS NO MORPHING
          aOut1 poscil kamp, kPitchInit ,gitableOscB
          aOut2 poscil kamp, kPitchInit ,gitableOscA
          aOut sum aOut1*.5 , aOut2*.5
          ;IF THERE IS SUBOSCIL
          ;- Region: ______ __With SubOscil
          if gkOscA_SubOsc >=0 then
              kSubPitch= kPitchInit *octave(gkOscA_SubOsc)
              aOutSub1 poscil kamp,kSubPitch ,gitableOscB
              aOutSub2 poscil kamp,kSubPitch ,gitableOscA
              aOutSub sum aOutSub1, aOutSub2
              aOut sum aOut*(1-gkOscA_SubOsc_Mix), aOutSub*gkOscA_SubOsc_Mix
          endif
      endif
  endif


  ;------------------------------------
  ;- Region: _Apply Ring Modulation
  if gkRing_On == 1 then
      aRing oscil gkRing_Amp,cent(gkRing_Freq) * kPitchInit,giSine
      aOut =aOut*(aRing+ gkRing_Offset)
  endif

  ;---------------------------------------
  ;- Region: _Audio Volume Enveloppe
  if gkADSR_Mod == 1     then
      kVolume_Envelope linenr gkADSR_Sustain, i(gkADSR_Attack), i(gkADSR_Decay), i(gkADSR_Release)
  elseif gkADSR_Mod == 2 then
      kVolume_Envelope madsr  i(gkADSR_Attack), i(gkADSR_Decay),i(gkADSR_Sustain), i(gkADSR_Release)
  elseif gkADSR_Mod == 3 then
      kVolume_Envelope mxadsr  i(gkADSR_Attack), i(gkADSR_Decay),i(gkADSR_Sustain), i(gkADSR_Release)
  elseif gkADSR_Mod == 4 then
      kVolume_Envelope linsegr  0, i(gkADSR_Attack),i(gkADSR_Sustain),i(gkADSR_Decay),i(gkADSR_Sustain), 0.1,1,i(gkADSR_Release) , 0
  endif
  
  ;---------------------------------------
  ;- Region: _Filter and apply envelopes
  if gkFilter_is_On==1 then
      if gkFilter_Type ==0 then
          aFilt My_Moogladder aOut, gkFilter_CutOff, gkFilter_Reson, gkFilter_PitchFollow,gkFilter_PitchFollow_Value, kPitchInit , \
          gkFilter_CutOff_LFO_is_On , gkFilter_CutOff_LFO_Mode ,gkFilter_CutOff_Amp, gkFilter_CutOff_Freq ,\
          gkFilter_Reson_LFO_is_On , gkFilter_Reson_LFO_Mode ,gkFilter_Reson_Amp, gkFilter_Reson_Freq
      elseif gkFilter_Type ==1 then
          aFilt My_LPF18 aOut, gkFilter_CutOff, gkFilter_Reson, gkFilter_PitchFollow,gkFilter_PitchFollow_Value, kPitchInit , \
          gkFilter_CutOff_LFO_is_On , gkFilter_CutOff_LFO_Mode ,gkFilter_CutOff_Amp, gkFilter_CutOff_Freq ,\
          gkFilter_Reson_LFO_is_On , gkFilter_Reson_LFO_Mode ,gkFilter_Reson_Amp, gkFilter_Reson_Freq, gkFilter_Distor
      elseif gkFilter_Type ==2 then
          aFilt My_BQRez aOut, gkFilter_CutOff, gkFilter_Reson, gkFilter_PitchFollow,gkFilter_PitchFollow_Value, kPitchInit , \
          gkFilter_CutOff_LFO_is_On , gkFilter_CutOff_LFO_Mode ,gkFilter_CutOff_Amp, gkFilter_CutOff_Freq ,\
          gkFilter_Reson_LFO_is_On , gkFilter_Reson_LFO_Mode ,gkFilter_Reson_Amp, gkFilter_Reson_Freq ,giBQrez_Type
      elseif gkFilter_Type ==3 then
          aFilt My_Tonex aOut, gkFilter_CutOff, gkFilter_PitchFollow,gkFilter_PitchFollow_Value, kPitchInit , \
          gkFilter_CutOff_LFO_is_On , gkFilter_CutOff_LFO_Mode ,gkFilter_CutOff_Amp, gkFilter_CutOff_Freq ,giToneLayer
      elseif gkFilter_Type ==4 then
          aFilt My_aTonex aOut, gkFilter_CutOff, gkFilter_PitchFollow,gkFilter_PitchFollow_Value, kPitchInit , \
          gkFilter_CutOff_LFO_is_On , gkFilter_CutOff_LFO_Mode ,gkFilter_CutOff_Amp, gkFilter_CutOff_Freq ,giAToneLayer
      endif
      ; If filtered signal has its own envelope, apply it
      if gkFilter_Env_is_On ==1 then
          kFiltADSR madsr i(gkFilter_Env_Att),i(gkFilter_Env_Dec),i(gkFilter_Env_Sus),i(gkFilter_Env_Rel)
          aOut = (1-gkFilter_Mix)*aOut*kVolume_Envelope +  aFilt * gkFilter_Mix*kFiltADSR
      else
          ;if not, then apply the Volume envelope
          aOut = ((1-gkFilter_Mix)*aOut + aFilt * gkFilter_Mix)*kVolume_Envelope
      endif
  else
      aOut = aOut *kVolume_Envelope
  endif

  ;-----------------------------------------
  ;- Region: _Apply Main Gain
  aOut =gkMainGain *aOut
  
  ;-----------------------------------------
  ;- Region: _Apply Flanger
  if gkFlanger_On==1 then
      aOut Flanger  aOut, gkFlanger_Depth,gkFlanger_Freq,gkFlanger_FeedBack
  endif

  ;-----------------------------------------
  ;- Region: _Apply Chorus
  if gkChorus_On==1 then
      aOut Chorus aOut, gkChorus_Rate,gkChorus_Min,gkChorus_Max,gkChorus_Mix
  endif

  ;-----------------------------------------
  ;- Region: _Apply Binaural
  if gkStereo == 1 then
      aleft,aright hrtfstat aOut, giAz, giElev, gSstereoL,gSstereoR  ;"C:/Users/Cube/Documents/Csound/hrtf-44100-left.dat","C:/Users/Cube/Documents/Csound/hrtf-44100-right.dat"
      ; aleft,aright  hrtfer aOut, gkaz, gkel, "HRTFcompact"
      aleft = aleft*2
      aright = aright*2
  else
      aleft = aOut
      aright= aOut
  endif

  ;-----------------------------------------
  ;- Region: _Out Audio
  outs     aleft, aright

  ;-----------------------------------------
  ;- Region: _Apply Echo
  if gkEcho_On==1 then
      chnmix aleft,"Echo_SendL"
      chnmix aright,"Echo_SendR"
  endif

  ;-----------------------------------------
  ;- Region:  Apply Reverb
  if gkReverb_On ==1 then
      chnmix aleft*gkReverb_Mix,"Reverb_SendL"
      chnmix aright*gkReverb_Mix,"Reverb_SendR"
  endif
  
  clear aleft,aright,aRing, aoscil,aOut1,aOut2,aOut,aoscilSub,aOutSub1,aOutSub2,aOutSub
  kmod_frq =0
  kmod_amp =0
  kamp =0
  kAftPitch =0
  kPchBnd =0
  kPitchInit =0
  kweightpoint =0
  kSubPitch =0
  kVolume_Envelope =0
endin




instr 	1	;INSTRUMENT THAT SCANS MIDI AND STARTS AND STOPS NOTES
	insno	=	801					;INSTRUMENT NUMBER OF INSTRUMENT TO BE TRIGGERED
	MIDI_trigger_instrument	insno,0				;CALL UDO FOR STARTING AND STOPPING NOTE VIA MIDI
endin



</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
;f0 z
i "InitData" 0 0.5
i "Main_Menu" 0.6 z
i "Manage_Groupbox" 0.6 z
;i 800 0.6 z
i 1 0 z
</CsScore>
</CsoundSynthesizer>
